package com.qmth.sop.business.bean;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.sop.business.bean.result.FlowTaskResult;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

@JsonInclude(JsonInclude.Include.NON_NULL)
public class FormPropertyBean implements Serializable {

    @ApiModelProperty(value = "流程id")
    @JsonSerialize(using = ToStringSerializer.class)
    Long flowId;

    @ApiModelProperty(value = "sopid")
    String sopId;

    @ApiModelProperty(value = "流程任务id")
    @JsonSerialize(using = ToStringSerializer.class)
    Long taskId;

    @ApiModelProperty(value = "用户id")
    @JsonSerialize(using = ToStringSerializer.class)
    Long userId;

    @ApiModelProperty(value = "动态表单")
    FlowTaskResult setupMap;

    public FormPropertyBean() {

    }

    public FormPropertyBean(Long flowId, Long taskId, FlowTaskResult setupMap) {
        this.flowId = flowId;
        this.taskId = taskId;
        this.setupMap = setupMap;
    }

    public FormPropertyBean(Long flowId, Long taskId, Long userId, FlowTaskResult setupMap) {
        this.flowId = flowId;
        this.taskId = taskId;
        this.userId = userId;
        this.setupMap = setupMap;
    }

    public String getSopId() {
        return sopId;
    }

    public void setSopId(String sopId) {
        this.sopId = sopId;
    }

    public Long getFlowId() {
        return flowId;
    }

    public void setFlowId(Long flowId) {
        this.flowId = flowId;
    }

    public Long getTaskId() {
        return taskId;
    }

    public void setTaskId(Long taskId) {
        this.taskId = taskId;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public FlowTaskResult getSetupMap() {
        return setupMap;
    }

    public void setSetupMap(FlowTaskResult setupMap) {
        this.setupMap = setupMap;
    }
}
